package cs618_project_code;
import java.sql.Connection;

import mysqltools.MySqlInsertBuffer;
import adjacencyenc.AdjacencyEncForest;
import configuration.Configuration;
import vldb2006.*;
import tools.LoadXMLForest;
import tree.LblTree;
import tree.LblValTree;

public class Real_Data {
	/*
	 * System.err.println("\nparams: table_name {adj|ie|ieLbl} file_1 ... file_n\n");
		
	 */
	public static void load_data(String args[]) throws Exception
	{
		LoadXMLForest obj = new LoadXMLForest();
		obj.load_forest(args);
	}
	
	public static void main(String args[]) throws Exception
	{
		Lookup obj = new Lookup();
		/*
		 * forest treeID p q tau");
		 */
		
		double p_fix[][] = new double[20][10];
		double q_fix[][] = new double[20][10];
		/*
		 * p fix
		 */
		String load_d[]=new String[4];
		String table="real";
		for(int j=0;j<5;j++)
		{
			table = table+j;
			load_d[0] = table;
			load_d[1] = "adj";
			load_d[2] = "C:\\varjava\\realdata\\"+table+"\\tdata1.xml";
			load_d[3] = "C:\\varjava\\realdata\\"+table+"\\tdata2.xml";
			load_data(load_d);
			Connection[] con = Configuration.getCons(4);
			DoEditOpsOnTree O = new DoEditOpsOnTree();
			AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
					new MySqlInsertBuffer(),table );
			LblValTree tr = f.loadTree(1);
			LblTree ltr1 = LblValTree.getLblTree(tr);
			int n = (j+1)*300;
			int p =3;
			int q =3;
			String arg[] = new String[4];
			arg[0] = table;
			arg[1] = ""+p;
			arg[2] = ""+q;
			arg[3] = ""+n;
			O.do_edit_ops(arg);
			tr = f.loadTree(1);
			LblTree ltr2 = LblValTree.getLblTree(tr);
			distance.TreeDist distFunc = null;
			
			
			/*
			 * p fix
			 */
			for(int i=0;i<20;i++)
			{
				distFunc = new distance.PQGramDist(3, i+1, false);
				p_fix[i][j] = distFunc.treeDist(ltr1, ltr2);
			
			}
		
		/*
		 * q fix
		 */
			for(int i=0;i<20;i++)
			{
				distFunc = new distance.PQGramDist(i+1, 3, false);
				q_fix[i][j] = distFunc.treeDist(ltr1, ltr2);
			
			}
			table = "real";
		}
		String output[]=new String[20];
		
		System.out.println("Q fix");
		for(int i=0;i<20;i++)
		{
			output[i]=""+i;
			for(int j=0;j<5;j++)
			{
				output[i]=output[i]+" "+q_fix[i][j];
			}
			System.out.println(output[i]);
		}
		System.out.println("P fix");
		for(int i=0;i<20;i++)
		{
			output[i]=""+i;
			for(int j=0;j<5;j++)
			{
				output[i]=output[i]+" "+p_fix[i][j];
			}
			System.out.println(output[i]);
		}
	}

}
