package mainmemory;

import java.sql.*;

import index.*;
import sqltools.*;
import adjacencyenc.*;

public class Ppart_Levels {
	
	public int current_level;
	public int max_level;
	public int Parent_Ids[];
	public Pparts pparts_obj[];
	public String pparts_n[];
	public boolean ischild;
	/**
	 * Function to get the child for the next level and update the current pparts
	 * @param p
	 * @param f
	 * @param nxt_level
	 * @param treeID
	 * @throws SQLException
	 */
	
	public void get_child_count(PPartTbl p,AdjacencyEncForest f,Ppart_Levels nxt_level,int treeID,String s) throws SQLException
	{
		int count=0;
		int len=Parent_Ids.length;
		
		
		//	System.out.println(len);
		for(int i=0;i<len;i++)
		{
			String comment="Getting all the children present at the next level";
			String query="SELECT `"+p.ATB_ANCHOR_ID+ "`,`"+p.ATB_PPART+"` FROM "+p.getTblName()+
			             " WHERE "+p.getAtbParentID()+"="+Parent_Ids[i]+" AND "+
			             p.getAtbTreeID()+"="+treeID;
			ResultSet rs=SQLTools.executeQuery(f.getStatement(), query, comment);
			while(rs.next())
			{
				
				
				count++;
				this.ischild=true;
				
			}
			
			
			
		}
		
		if(ischild)
		{
			nxt_level.Parent_Ids=new int[count];
			pparts_n=new String[count];
			
		}
		else
		{
			nxt_level.Parent_Ids=null;
			
		}
		
		count=0;
		
		if(ischild)
		{
			for(int i=0;i<len;i++)
			{
				String comment="Getting all the children present at the next level";
				String query="SELECT `"+p.ATB_ANCHOR_ID+ "`,`"+p.ATB_PPART+"` FROM "+p.getTblName()+
				             " WHERE "+p.getAtbParentID()+"="+Parent_Ids[i]+" AND "+
				             p.getAtbTreeID()+"="+treeID;
			    ResultSet rs=SQLTools.executeQuery(f.getStatement(), query, comment);
			    while(rs.next())
				{
			    	int l1;
			 //   	System.out.println(current_level);
					String olds=rs.getString(p.getAtbPPart());
					if(current_level!=0)
					{
						
						l1=(current_level+1)*(p.getHf().getLength());
				//		System.out.println(l1);
					}
					else
					{
						l1=(current_level+1)*(p.getHf().getLength());
					}
				//	System.out.println(olds.substring(s.length()-l1));
					pparts_n[count]="".concat(s.substring(l1)).concat(olds.substring(s.length()-l1));
					nxt_level.Parent_Ids[count]=rs.getInt(p.getAtbAnchorID());
					ischild=true;
					count++;
					
				}
				
				
				
			}
			
			update_ppart_1(treeID,p,nxt_level);
			
		}
		else
		{
			nxt_level.Parent_Ids=null;
		}
		
		
		
		
	
		
		/*
		 * call function to update the current level pparts
		 */
	}
	
	
	
	
	
	
	
	
	
	
	
	
	public void get_child_count_D(PPartTbl p,AdjacencyEncForest f,Ppart_Levels nxt_level,int treeID,String s) throws SQLException
	{
		int count=0;
		int len=Parent_Ids.length;
		
		
		//	System.out.println(len);
		for(int i=0;i<len;i++)
		{
			String comment="Getting all the children present at the next level";
			String query="SELECT `"+p.ATB_ANCHOR_ID+ "`,`"+p.ATB_PPART+"` FROM "+p.getTblName()+
			             " WHERE "+p.getAtbParentID()+"="+Parent_Ids[i]+" AND "+
			             p.getAtbTreeID()+"="+treeID;
			ResultSet rs=SQLTools.executeQuery(f.getStatement(), query, comment);
			while(rs.next())
			{
				
				
				count++;
				this.ischild=true;
				
			}
			
			
			
		}
		
		if(ischild)
		{
			nxt_level.Parent_Ids=new int[count];
			pparts_n=new String[count];
			
		}
		else
		{
			nxt_level.Parent_Ids=null;
			
		}
		
		count=0;
		
		if(ischild)
		{
			for(int i=0;i<len;i++)
			{
				String comment="Getting all the children present at the next level";
				String query="SELECT `"+p.ATB_ANCHOR_ID+ "`,`"+p.ATB_PPART+"` FROM "+p.getTblName()+
				             " WHERE "+p.getAtbParentID()+"="+Parent_Ids[i]+" AND "+
				             p.getAtbTreeID()+"="+treeID;
			    ResultSet rs=SQLTools.executeQuery(f.getStatement(), query, comment);
			    while(rs.next())
				{
			    	int l1;
			   // 	System.out.println(current_level);
					String olds=rs.getString(p.getAtbPPart());
					if(current_level!=0)
					{
						
						l1=(current_level)*(p.getHf().getLength());
				//		System.out.println(l1);
					}
					else
					{
						l1=(current_level)*(p.getHf().getLength());
					}
				//	System.out.println(olds.substring(s.length()-l1));
					pparts_n[count]="".concat(s.substring(l1)).concat(olds.substring(s.length()-l1));
					nxt_level.Parent_Ids[count]=rs.getInt(p.getAtbAnchorID());
					ischild=true;
					count++;
					
				}
				
				
				
			}
			
			update_ppart_1(treeID,p,nxt_level);
			
		}
		else
		{
			nxt_level.Parent_Ids=null;
		}
		
		
		
		
	
		
		/*
		 * call function to update the current level pparts
		 */
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/**
	 * Function to call the last level
	 * @param p
	 * @param f
	 * @param nxt_level
	 * @param treeID
	 * @throws SQLException
	 */
	
	
	
	
	
	
	
	public void get_child_count(PPartTbl p,AdjacencyEncForest f,int treeID,String s) throws SQLException
	{
		int count=0;
		if(Parent_Ids!=null)
		{
		int len=Parent_Ids.length;
	//	update_ppart(treeID,p,s);
		
		/*
		 * call function to update the current level pparts
		 */
		}
		else
		{
			
		}
	}
	
	
	public void update_ppart_1(int treeID,PPartTbl p,Ppart_Levels nxt_level) throws SQLException
	
	{
		int len=pparts_n.length;
		for(int i=0;i<len;i++)
		{
			p.updatePpart(treeID, nxt_level.Parent_Ids[i], pparts_n[i]);
			
		}
		
	}
	
	
	public void update_ppart(int treeID,PPartTbl p,String s) throws SQLException
	{
		int len=Parent_Ids.length;
		for(int i=0;i<len;i++)
		{
			
			int anchorID=Parent_Ids[i];
			String oldstring=p.getPPartStr(treeID, anchorID);
			String new_str;
			int P=p.getP();
			int index=(P-1)-current_level;
			int l1;
		//	System.out.println(current_level);
			if(current_level!=0)
			{
				l1=(current_level)*(p.getHf().getLength());
			}
			else
			{
				l1=0;
			}
			
			int l2=s.length()-l1;
			String new_str1;
			System.out.println(s);
	//		System.out.println(l1+" l2 "+l2);
			System.out.println(oldstring);
			new_str1="".concat(s.substring(l1)).concat(oldstring.substring(l2));
			
			new_str="".concat(s.substring(0,index*p.getHf().getLength())).concat(oldstring.substring(index*p.getHf().getLength()));
			System.out.println(new_str1);
			System.out.println(" new str "+new_str);
			p.updatePpart(treeID, anchorID, new_str);
		}
		
	}
	
	

}
