package mainmemory;

import adjacencyenc.*;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import sqltools.*;

import hash.*;

public class getpparts
{
	public LinkedList getAnchestors(AdjacencyEncForest f, int treeID, int nodeID, int length,
			FixedLengthHash hf) throws SQLException {		
		LinkedList anc = new LinkedList();
		int k = 0;
		long start = System.currentTimeMillis();
		for (int i = 0; i < length; i++) {
			String query = "SELECT " + f.getAtbLabel()+ "," + f.getAtbParentID() + " FROM `"
					+ f.getTblName() + "` WHERE " + f.getAtbTreeID() + "=" + treeID
					+ " AND " + f.getAtbNodeID() + "=" + nodeID;
			ResultSet rs = f.getStatement().executeQuery(query);
			if (rs.next()) {
				anc.addLast(hf.getHashValue(rs.getString(f.getAtbLabel())));
		    //  System.out.println(k);
			//	System.out.println(hf.getHashValue(rs.getString(f.getAtbLabel())));
				System.out.println(rs.getString(f.getAtbLabel())+"  "+hf.getHashValue(rs.getString(f.getAtbLabel())));
				k++;
				nodeID = rs.getInt(f.getAtbParentID());
			} else {
				break;
			}
		}
		if (SQLTools.DEBUG) {
			System.out.println("Got " + length + " anchestors of node " + nodeID 
					+ " in " + (System.currentTimeMillis() - start) + "ms.");
		}
		for (int i = k; i < length; i++) {
			anc.addLast(hf.getNullNode());
			 System.out.println("NULL p part  "+hf.getNullNode());
		}
		
		return anc;
	}
	
	public int parentid(AdjacencyEncForest f, int treeID, int nodeID,FixedLengthHash hf) 
	throws SQLException
	{
		int parentID;
		String query = "SELECT " + f.getAtbLabel()+ "," + f.getAtbParentID() + " FROM `"
		+ f.getTblName() + "` WHERE " + f.getAtbTreeID() + "=" + treeID
		+ " AND " + f.getAtbNodeID() + "=" + nodeID;
ResultSet rs = f.getStatement().executeQuery(query);
		
		if (rs.next()) {
			parentID = rs.getInt(f.getAtbParentID());
		}
		else
		{
			parentID=-2;
			System.out.println("No Node Exist with the given nodeID");
		}
		return parentID;
		
	}
	
	public int sibposition(AdjacencyEncForest f, int treeID, int nodeID,FixedLengthHash hf)
	throws SQLException
	{
		int position;
		String query = "SELECT " + f.getAtbLabel()+ "," + f.getAtbParentID() +","+f.getAtbSibPos()+ " FROM `"
		+ f.getTblName() + "` WHERE " + f.getAtbTreeID() + "=" + treeID
		+ " AND " + f.getAtbNodeID() + "=" + nodeID;
		ResultSet rs = f.getStatement().executeQuery(query);
		if(rs.next())
		{
			position=rs.getInt(f.getAtbSibPos());
			
		}
		else
		{
			position=-1;
			System.out.println("No nodw with "+nodeID+" exist");
		}
		return position;
	}
	
	
}