package mainmemupdate;

import hash.FixedLengthHash;
import hash.HashValue;

import java.util.*;

import mainmemory.*;
import adjacencyenc.*;
import java.sql.*;

/** 
 * This class is going to update the index when rename is done
 * @ author Varunesh Mishra
 */

public class List_Buffer_PParts_QParts {
	
	
	
	
	
	public List_Buffer_PParts_QParts()
	{
		
	}
	
	/**
	 * LINKEDLIST FUNCTIONS ARE HERE
	 */
	
	public LinkedList parentppart_List(AdjacencyEncForest f, int treeID, int nodeID, int p,
			FixedLengthHash hf) throws SQLException
	{
		LinkedList Parent_PPart=new LinkedList();
		getpparts obj=new getpparts();
		Parent_PPart=obj.getAnchestors(f, treeID, nodeID, p, hf);
		return Parent_PPart;
	}
	
	public LinkedList[] qpart_km(AdjacencyEncForest f,int k, int m,int p, int q, int treeID, int parentID,FixedLengthHash hf)
	throws SQLException
	{
		LinkedList Qpartkm[]=new LinkedList[(m+q-1-k)];
		ResultSet rs = null;
		int check=1;
		System.out.println(k);
		int val=0;
		
			if((k-q)>=0)
			{
				// call the children of the parents 
				// from k-q+1 to k+q-1
				int i;
				rs=f.getChildren(treeID, parentID, k-q+1, m+q-1);
				for( i=0;i<q;i++)
				{
					if(rs.next())
					{
						Qpartkm[val].addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
						//	System.out.println(rs.getString(f.getAtbLabel()));
						//	System.out.println("Varunesh");
						check++;
					}
					else
					{
						break;
					}
				}
				if(i<q)
				{
					for(;i<q;i++)
					{
						Qpartkm[val].addFirst(hf.getNullNode());
					}
				}
			}
		
		
			else
			{
				// first add |k-q| times null node and then shift them one by one 
				for(int i=0;i<(q-k);i++)
				{
					Qpartkm[val].addFirst(hf.getNullNode());
				// add null nodes and add the first child for the initial q part
				}
			}
		

		val++;
		int childcount = f.getChildCount(treeID, parentID);
		for(int j=k;j<m+q-1;j++)
		{
			if(rs.next())
			{
				Qpartkm[val].removeLast();
				Qpartkm[val].addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
				System.out.println(rs.getString(f.getAtbLabel()));
				System.out.println("varun");
			}
			else
			{
				Qpartkm[val].removeLast();
				Qpartkm[val].addFirst(hf.getNullNode());
				System.out.println("null");
			}
			val++;
		}
		return Qpartkm;
		
	}
	
	public LinkedList[] qpart_kk(AdjacencyEncForest f,int k,int p, int q, int treeID, int parentID,FixedLengthHash hf)
	throws SQLException
	{
		/**
		 * It is always a Q*Q matrix
		 */
		LinkedList Qpartkk[]=new LinkedList[q];
		ResultSet rs = null;
		int check=1;
		System.out.println(k);
		int val=0;
		
			if((k-q)>=0)
			{
				// call the children of the parents 
				// from k-q+1 to k+q-1
				int i;
				rs=f.getChildren(treeID, parentID, k-q+1, k+q-1);
				for( i=0;i<q;i++)
				{
					if(rs.next())
					{
						Qpartkk[val].addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
						//	System.out.println(rs.getString(f.getAtbLabel()));
						//	System.out.println("Varunesh");
						check++;
					}
					else
					{
						break;
					}
				}
				if(i<q)
				{
					for(;i<q;i++)
					{
						Qpartkk[val].addFirst(hf.getNullNode());
					}
				}
			}
		
		
			else
			{
				// first add |k-q| times null node and then shift them one by one 
				for(int i=0;i<(q-k);i++)
				{
					Qpartkk[val].addFirst(hf.getNullNode());
				// add null nodes and add the first child for the initial q part
				}
			}
		

		val++;
		int childcount = f.getChildCount(treeID, parentID);
		for(int j=k;j<k+q-1;j++)
		{
			if(rs.next())
			{
				Qpartkk[val].removeLast();
				Qpartkk[val].addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
				System.out.println(rs.getString(f.getAtbLabel()));
				System.out.println("varun");
			}
			else
			{
				Qpartkk[val].removeLast();
				Qpartkk[val].addFirst(hf.getNullNode());
				System.out.println("null");
			}
			val++;
		}
		return Qpartkk;
	}
	
	
	/*
	 * STRING BUFFER FUNCTIONS BEGIN FROM HERE
	 */
	
	
	public StringBuffer parentppart(AdjacencyEncForest f, int treeID, int nodeID, int p,
			FixedLengthHash hf) throws SQLException
	{
		StringBuffer parppart;
		ppartload pobj=new ppartload();
		System.out.println("the ppart");
		parppart=pobj.ppartbuffer(f,treeID,nodeID,p,hf);
		System.out.println(parppart);
		return parppart;
		
	}
	
	
	// for delete and rename m=k;
	public StringBuffer[] qpartkm(AdjacencyEncForest f,int k, int m, int q, int treeID, int parentID,FixedLengthHash hf)
	throws SQLException
	{
		StringBuffer [] sb = new StringBuffer[q];
		LinkedList<HashValue> ls=new LinkedList<HashValue>();
		ResultSet rs = null;
		int check=1;
		System.out.println(k);
		if((k-q)>=0)
		{
			// call the children of the parents 
			// from k-q+1 to k+q-1
			int i;
			rs=f.getChildren(treeID, parentID, k-q+1, m+q-1);
			for( i=0;i<q;i++)
			{
				if(rs.next())
				{
					ls.addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
				//	System.out.println(rs.getString(f.getAtbLabel()));
				//	System.out.println("Varunesh");
					check++;
				}
				else
				{
					break;
				}
			}
			if(i<q)
			{
				for(;i<q;i++)
				{
					ls.addFirst(hf.getNullNode());
				}
			}
		}
		
		else
		{
			// first add |k-q| times null node and then shift them one by one 
			for(int i=0;i<(q-k);i++)
			{
				ls.addFirst(hf.getNullNode());
				// add null nodes and add the first child for the initial q part
			}
		}
		int counter=0;
		// again I have to do check whether it is retreiving the last number of children or not
		
		StringBuffer temp=new StringBuffer();
		for (ListIterator<HashValue> it = ls.listIterator(ls.size()); it.hasPrevious();)
		{
				
	         String s = ((HashValue)it.previous()).toString();
	         temp.append(s);
	         
	    }
		sb[counter]=temp;
		counter++;
		int childcount = f.getChildCount(treeID, parentID);
		for(int j=k;j<m+q-1;j++)
		{
			if(rs.next())
			{
				ls.removeLast();
				ls.addFirst(hf.getHashValue(rs.getString(f.getAtbLabel())));
				System.out.println(rs.getString(f.getAtbLabel()));
				System.out.println("varun");
			}
			else
			{
				ls.removeLast();
				ls.addFirst(hf.getNullNode());
				System.out.println("null");
			}
			StringBuffer temp1=new StringBuffer();
			for (ListIterator<HashValue> it = ls.listIterator(); it.hasNext();)
			{
				//System.out.println(it.previous().toString());	
		         String s = ((HashValue)it.next()).toString();
		         temp1.append(s);
		         
		    }
			sb[counter]=temp1;
			counter++;
		}
		return sb;
	}
	
	public StringBuffer[] pqgramkk(AdjacencyEncForest f,int k, int m,int p, int q, int treeID, int parentID,FixedLengthHash hf)
	throws SQLException
	{
		
		// call the above two functions and merge them
		StringBuffer pqgkm[]  = new StringBuffer[q];
		StringBuffer qtemp[]= new StringBuffer[q];
		StringBuffer ptemp  = new StringBuffer();
		ptemp=parentppart(f,treeID,parentID,p,hf);
		qtemp=qpartkm(f,k,m,q,treeID,parentID,hf);
		System.out.println("The p part is here");
		System.out.println(ptemp);
		
		for(int i=0;i<q;i++)
		{
			StringBuffer temp1=new StringBuffer();
			temp1.append(ptemp);
		//	System.out.println(qtemp[i]);
			pqgkm[i]=temp1.append(qtemp[i]);
			System.out.println(pqgkm[i]);
			System.out.println("................");
		}
		
		return pqgkm;
	}
	
	
	

}
