package indexing;

import java.util.Iterator;
import java.util.LinkedList;



import random.RandomVal;
import distance.Profile;
import distance.ProfileDist;
import others.*;

class Node
{
	Profile prf;
	double mean;
	double var;
}

class Refer_n
{
	Profile p;
	double d[];
	public Refer_n(int n)
	{
		d = new double[n];
	}
}

public class References {
	
	LinkedList pq_profiles_List = new LinkedList();
	LinkedList Node_List = new LinkedList();
	
	
		
	public LinkedList reference_set(int m,int p,int q,double perc)
	{
		int n;
		RandomVal rand = new RandomVal();
		n = pq_profiles_List.size();
		double mean[] = new double[n];
		double variance[] = new double[n];
		
		LinkedList mean_List = new LinkedList();
		LinkedList variance_List = new LinkedList();
		LinkedList refer_List = new LinkedList();
		distance.TreeDist distFunc = null;
		distFunc = new distance.PQGramDist(p, q, false);
		double var = 0.0;
		double mn = 0.0;
		
		for(int i=0;i<n;i++)
		{
			mean[i] = 0.0;
			mn = 0.0;
			int lmt = rand.getInt(1, n);
			Profile temp = (Profile)pq_profiles_List.get(i);
			Node obj = new Node();
			double ds[] = new double[lmt];
			for(int j=0;j<lmt;j++)
			{
				int  x = rand.getInt(0, n-1);
				ds[j] = distFunc.profile_dis(temp, (Profile)pq_profiles_List.get(x));
				mn = mn + ds[j];
			}
			mn =mn / n;
			//mean_List.add(i,mn);
			var = 0.0;
			for(int j=0;j<lmt;j++)
			{
				var = var + (ds[j] - mn)*(ds[j] - mn);
			}
			var = var / n;
			int pos=0;
			for(Iterator it = variance_List.iterator(); it.hasNext();) {
				double v = (Double)it.next();
				if(v<var)
				{
					break;
				}
				else
				{
					pos++;
				}
			}
			mean_List.add(pos,mn);
			variance_List.add(pos, var);
			pq_profiles_List.remove(i);
			pq_profiles_List.add(pos,temp);
			
			
		}
		
		double w = 0;
		int cnt = 0;
		System.out.println();
		LinkedList pq_clone = (LinkedList)pq_profiles_List.clone();
		System.out.println("pqg size is "+pq_profiles_List.size());
		System.out.println("clone "+pq_clone.size());
		while(cnt < m)
		{
			System.out.println("clone "+pq_clone.size());
			Profile obj;
			obj = (Profile)pq_clone.getFirst();
			w = obj.size()*2.0;
			refer_List.addLast(obj);
			pq_clone.removeFirst();
			cnt++;
			for(Iterator it = pq_profiles_List.iterator(); it.hasNext();) {
				Profile temp = (Profile)it.next();
				double d1  = distFunc.profile_dis(obj, temp);
				if(d1 < ((Double)mean_List.getFirst() - w) || d1 > ((Double)mean_List.getFirst() + w))
				{
					System.out.println(d1);
					pq_clone.remove(temp);
				}
				
			}
			mean_List.removeFirst();
			variance_List.removeFirst();
		}
		return refer_List;
	}

}
