package others;

import java.util.LinkedList;

import distance.Profile;

/**
 *  @author varunesh
 */


public class QuickSort {
    private static long comparisons = 0;
    private static long exchanges   = 0;

    public static void quicksort(double[] variance,double mean[],Profile ref[]) {
        //shuffle(a);                        // to guard against worst-case
        quicksort(variance,mean,ref,0,variance.length - 1);
    }

    // quicksort a[left] to a[right]
    public static void quicksort(double[] variance,double mean[],Profile ref[], int left, int right) {
        if (right <= left) return;
        int i = partition(variance,mean,ref, left, right);
        quicksort(variance,mean,ref, left, i-1);
        quicksort(variance, mean,ref,i+1, right);
    }

    // partition a[left] to a[right], assumes left < right
    private static int partition(double[] variance,double mean[],Profile ref[], int left, int right) {
        int i = left - 1;
        int j = right;
        while (true) {
            while (less(variance[++i], variance[right]))      // find item on left to swap
                ;                               // a[right] acts as sentinel
            while (less(variance[right], variance[--j]))      // find item on right to swap
                if (j == left) break;           // don't go out-of-bounds
            if (i >= j) break;                  // check if pointers cross
            exch(variance,mean,ref, i, j);                      // swap two elements into place
        }
        exch(variance,mean,ref, i, right);                      // swap with partition element
        return i;
    }

    // is x < y ?
    private static boolean less(double x, double y) {
        comparisons++;
        return (x < y);
    }

    // exchange a[i] and a[j]
    private static void exch(double[] mean, double variance[],Profile ref[], int i, int j) {
        exchanges++;
        double swap1 = variance[i];
        double swap2 = mean[i];
        Profile swap3 =  ref[i];
        variance[i] = variance[j];
        variance[j] = swap1;
        mean[i] = mean[j];
        mean[j] = swap2;
        ref[i] = ref[j];
        ref[j] = swap3;
    }

    // shuffle the array a[]
    private static void shuffle(double[] a) {
        int N = a.length;
        for (int i = 0; i < N; i++) {
            int r = i + (int) (Math.random() * (N-i));   // between i and N-1
          //  exch(a, i, r);
        }
    }


    public static void qsort_list(LinkedList var,LinkedList mean,LinkedList Prof)
    {
    	
    }

    // test client
    public static void main(String[] args) {
        
    }
}


