package cs618_project_code;

import java.util.*;
import random.*;

class Node
{
	int nodeID;
	int parentID;
	int sibpos;
	boolean isleaf;
	Node child[];
	
	public String toString()
	{
		return "nodeID "+nodeID;
	}
	
	
	
}

class Node1
{
	int nodeID;
	int parentID;
	int sibpos;
	boolean isleaf;
	Node1 child[];
	String lbl=new String();
	public String toString()
	{
		return "nodeID "+nodeID;
	}
}

public class Tree_Generate {
	
	public static LinkedList labels=new LinkedList();
	public static Node1 inserted = new Node1();
	public static Node nd = new Node();
	
	
	public static void set_labels(int len,int no_label)
	{
		int cnt = 0;
		//stem.out.println("varunesh");
		String temp = Random_String.randomstring(len, len);
		while(cnt<no_label)
		{
			
			temp = Random_String.randomstring(len, len);
			if(labels.size()>=no_label)
			{
				break;
			}
			if(!labels.contains(temp))
			{
				//System.out.println("varunesh "+temp);
				labels.addLast(temp);
				cnt++;
			}
		}
	}
	
	public static void tree(Node node)
	{
		Random obj = new Random();
		if(node.isleaf==true)
		{
			int r = obj.nextInt(labels.size());
			System.out.print("{"+labels.get(r)+"}");
		}
		else
		{
			int r = obj.nextInt(labels.size());
			System.out.print("{"+labels.get(r));
			for(int i=0;i<node.child.length;i++)
			{
				tree(node.child[i]);
			}
			System.out.print("}");
		}
			
	}
	
	public static String tree_label(Node node)
	{
		Random obj = new Random();
		if(node.isleaf==true)
		{
			int r = obj.nextInt(labels.size());
			return "{"+labels.get(r)+"}";
		}
		else
		{
			int r = obj.nextInt(labels.size());
			String temp = "{"+labels.get(r);
			for(int i=0;i<node.child.length;i++)
			{
				temp = temp + tree_label(node.child[i]);
			}
			temp = temp +"}";
			return temp;
			
		}
		
	}
	
	public static String tree_label1(Node1 node)
	{
		Random obj = new Random();
		if(node.isleaf==true)
		{
			
			return "{"+node.lbl+"}";
		}
		else
		{
			
			String temp = "{"+node.lbl;
			for(int i=0;i<node.child.length;i++)
			{
				temp = temp + tree_label1(node.child[i]);
			}
			temp = temp +"}";
			return temp;
			
		}
		
	}
	
	public static String treefromList(LinkedList lst,Node1 node)
	{
		String str = "";
		Node1 temp = new Node1();
		//System.out.println("varunesh "+node.lbl+ " nodeid "+node.nodeID);
		int ind = lst.indexOf(node);
		System.out.println("ind "+ind+" size "+lst.size());
		temp = (Node1)lst.get(ind);
		if(temp.isleaf)
		{
			
			str = "{"+temp.lbl+"}";
			//System.out.println("str "+str);
		}
		else
		{
			str = "{"+temp.lbl;
			//System.out.println("str "+str);
			Node1 loop = new Node1();
			ind = 0;
			for(int i=0;i<temp.child.length;i++)
			{
				for(Iterator it = lst.iterator(); it.hasNext();) {
					loop = (Node1)it.next();
					if(loop.nodeID==temp.child[i].nodeID)
					{
						System.out.println("var "+loop.isleaf);
						break;
					}
					System.out.println("index in loop"+ind);
					ind++;
				}
				Node1 temp2 = (Node1)lst.get(ind);
				System.out.println("varunesh");
				System.out.println(temp.child[i].lbl+" "+temp.child[i].nodeID+" "+temp.child.length);
				//System.out.println(temp2.child[i].lbl+" "+temp2.child[i].nodeID+" "+temp2.child.length);
				str = str + treefromList(lst,temp2);
				ind = 0;
			}
			str = str +"}";
			//System.out.println("str "+str);
			
		}
		return str;
	}
	
	
	
	
	public static String[] Str_tree(int kval,int mean,double dev,int lset_size)
	{
		String str[]=new String[2];
		str[0]="";
		str[1]="";
		int cnt=0;
		int sibpos=0;
		LinkedList tree = new LinkedList();
		LinkedList Leaf = new LinkedList();
		Node root = new Node();
		root.nodeID = 0;
		root.parentID = -1;
		root.sibpos  = -1;
		root.isleaf = true;
		Leaf.addLast(root);
		tree.addLast(root);
		cnt++;
		int k = kval;
		for(int i=0;i<k-1;i++)
		{ 
			int s = Leaf.size();
			RandomVal rndI = new RandomVal();
			int sl = rndI.getInt(0, s-1);
			Node sel_Leaf = (Node)Leaf.get(sl);
			Leaf.remove(sl);
			/*
			 * Generate a random value for this
			 */
			Random gauss = new Random();
			double stdDev = dev;
			int no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			while(no_child<=0)
			{
				no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			}
			sibpos=0;
			sel_Leaf.child=new Node[no_child];
			for(int j=0;j<no_child;j++)
			{
				Node temp = new Node();
				temp.nodeID=cnt;
				temp.parentID=sel_Leaf.nodeID;
				temp.sibpos=sibpos;
				temp.isleaf=true;
				sel_Leaf.child[j]=temp;
				int ind = tree.indexOf(sel_Leaf);
				sel_Leaf.isleaf = false;
				tree.set(ind, sel_Leaf);
				tree.addLast(temp);
				Leaf.addLast(temp);
				sibpos++;
				cnt++;
				
			}
			
			
			
			
			
		}
		
		System.out.println("My name is varunesh");
		/*
		 * Tree Traversal
		 */
		Node t = new Node();
		t = (Node)tree.getFirst();
		System.out.println(t.toString());
		System.out.println("size is "+tree.size());
		System.out.println(" "+t.child[0].toString());
		set_labels(2,lset_size);
		str[0]=tree_label(root);
		
		
		
		
		System.out.println();
		
		cnt=0;
		sibpos=0;
		LinkedList tree1 = new LinkedList();
		LinkedList Leaf1 = new LinkedList();
		Node root1 = new Node();
		root1.nodeID = 0;
		root1.parentID = -1;
		root1.sibpos  = -1;
		root1.isleaf = true;
		Leaf1.addLast(root1);
		tree1.addLast(root1);
		cnt++;
		k = kval;
		for(int i=0;i<k-1;i++)
		{ 
			int s = Leaf1.size();
			RandomVal rndI = new RandomVal();
			int sl = rndI.getInt(0, s-1);
			Node sel_Leaf = (Node)Leaf1.get(sl);
			Leaf1.remove(sl);
			/*
			 * Generate a random value for this
			 */
			Random gauss = new Random();
			double stdDev = dev;
			int no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			while(no_child<=0)
			{
				no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			}
			sibpos=0;
			sel_Leaf.child=new Node[no_child];
			for(int j=0;j<no_child;j++)
			{
				Node temp = new Node();
				temp.nodeID=cnt;
				temp.parentID=sel_Leaf.nodeID;
				temp.sibpos=sibpos;
				temp.isleaf=true;
				sel_Leaf.child[j]=temp;
				int ind = tree1.indexOf(sel_Leaf);
				//System.out.println("ind"+ind);
				sel_Leaf.isleaf = false;
				tree1.set(ind, sel_Leaf);
				tree1.addLast(temp);
				Leaf1.addLast(temp);
				sibpos++;
				cnt++;
				
			}
			
			
			
			
			
		}
		
		System.out.println("My name is varunesh");
		/*
		 * Tree Traversal
		 */
		Node t1 = new Node();
		t1 = (Node)tree.getFirst();
		System.out.println(t1.toString());
		System.out.println("size is "+tree.size());
		System.out.println(" "+t1.child[0].toString());
		str[1]=tree_label(root1);
		
		
		
		return str;
	}
	
	
	public static Node1[] nodes(Node1 n,Node1 p,int id)
	{
		Node1 n1[]= new Node1[2];
		if(n.nodeID == id)
		{
			n1[0]=n;
			n1[1]=p;
		}
		else
		{
			
		}
		return n1;
	}
	
	public static void delete(Node1 n,Node1 p,int nid)
	{
		if(n.nodeID == nid)
		{
			if(n.isleaf)
			{
				//System.out.println("inleaf");
				if(p.child.length == 1)
				{
					p.isleaf = true;
					p.child = null;
				}
				else
				{
					//System.out.println("parent  was having more children");
					Node1 temp[] = new Node1[p.child.length];
					temp = p.child.clone();
					//System.out.println(temp.length);
					p.child = new Node1[p.child.length - 1];
					for(int j=0;j<n.sibpos;j++)
					{
						//System.out.println(n.sibpos);
						p.child[j]=temp[j];
					}
					for(int j=n.sibpos;j<p.child.length;j++)
					{
						p.child[j]=temp[j+1];
						p.child[j].sibpos = temp[j+1].sibpos - 1; 
					}
					
					
				}
			}
			else
			{
				//System.out.println("inleaf2");
				
				Node1 temp[] = new Node1[p.child.length];
				temp = p.child.clone();
				p.child = new Node1[p.child.length+n.child.length-1];
				for(int j=0;j<n.sibpos;j++)
				{
					p.child[j]=temp[j];
				}
				for(int j=n.sibpos;j<n.sibpos+n.child.length;j++)
				{
					p.child[j]=n.child[j-n.sibpos];
					p.child[j].sibpos = j;
					p.child[j].parentID = n.nodeID;
				}
				for(int j=n.sibpos;j<temp.length-1;j++)
				{
					p.child[j+n.child.length]=temp[j+1];
					p.child[j+n.child.length].sibpos = temp[j+1].sibpos+n.child.length - 1;
				}
			
			}
		}
		else
		{
			if(n.isleaf)
			{
				//System.out.println("breakpoint");
			}
			else
			{
				for(int i=0;n.child!=null && i<n.child.length;i++)
				{
					//System.out.println("inloop");
					delete(n.child[i],n,nid);
				}
			}
		}
	}
	
	
	public static void insert(Node1 n,Node1 p,int id,String lbl,int k,int m)
	{
		if(n.nodeID == p.nodeID)
		{
			Node1 nd = new Node1();
			if(p.isleaf)
			{
				p.child = new Node1[1];
				nd.child = null;
				nd.isleaf = true;
				nd.nodeID = id;
				nd.lbl = lbl;
				p.child[0]  = nd;
				p.isleaf = false;
			}
			
			else
			{
				if(m == 0)
				{
					nd.child = null;
					nd.isleaf = true;
					nd.sibpos = 0;
				}
				else
				{
					nd.child = new Node1[m];
					nd.isleaf = false;
					for(int j=0;j<m;j++)
					{
						nd.child[j] = p.child[k+j];
						nd.child[j].parentID = nd.nodeID;
						nd.child[j].sibpos = j;
					}
				}
				nd.nodeID = id;
				nd.parentID = p.nodeID;
				nd.lbl = lbl;
			
				if(m == 0)
				{
				
					Node1 temp[] = p.child.clone();
					p.child = new Node1[p.child.length+1];
					for(int j=0;j<k;j++)
					{
						p.child[j] = temp[j];
					}
					p.child[k] = nd;
					p.child[k].sibpos = k;
					for(int j=k;j<temp.length;j++)
					{
						p.child[j+1]=temp[j];
						p.child[j+1].sibpos = temp[j].sibpos+1;
					}
				}
				else
				{
					Node1 temp[] = p.child.clone();
					p.child = new Node1[p.child.length-m+1];
					for(int j=0;j<k;j++)
					{
						p.child[j] = temp[j];
					}
					p.child[k] = nd;
					p.child[k].sibpos = k;
					for(int j=k+1;j<p.child.length;j++)
					{
						p.child[j] = temp[j+m-1];
						p.child[j].sibpos = j;
					}
				}
			}
			inserted = nd;
		}
		else
		{
			if(n.isleaf)
			{
				
			}
			else
			{
				for(int i=0;i<n.child.length;i++)
				{
					insert(n.child[i],p,id,lbl,k,m);
				}
			}
		}
		
		
	}
	
	
	public static void rename(Node1 n,String nlbl,int id)
	{
		
		if(n.nodeID == id)
		{
			n.lbl = nlbl;
		}
		else
		{
			if(n.isleaf)
			{
				
			}
			else
			{
				/*
				 * Go to every child recursively
				 */
				for(int i=0;i<n.child.length;i++)
				{
					rename(n.child[i],nlbl,id);
				}
			}
		}
	}
	
	
	public static Node tree_database(int k)
	{
		int cnt=0;
		int sibpos=0;
		LinkedList tree = new LinkedList();
		LinkedList Leaf = new LinkedList();
		Node root = new Node();
		root.nodeID = 0;
		root.parentID = -1;
		root.sibpos  = -1;
		root.isleaf = true;
		Leaf.addLast(root);
		tree.addLast(root);
		cnt++;
		for(int i=0;i<k-1;i++)
		{ 
			int s = Leaf.size();
			RandomVal rndI = new RandomVal();
			int sl = rndI.getInt(0, s-1);
			Node sel_Leaf = (Node)Leaf.get(sl);
			Leaf.remove(sl);
			/*
			 * Generate a random value for this
			 */
			Random gauss = new Random();
			int mean =5;
			double stdDev = 5.0;
			int no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			while(no_child<=0)
			{
				no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			}
			sibpos=0;
			sel_Leaf.child=new Node[no_child];
			for(int j=0;j<no_child;j++)
			{
				Node temp = new Node();
				temp.nodeID=cnt;
				temp.parentID=sel_Leaf.nodeID;
				temp.sibpos=sibpos;
				temp.isleaf=true;
				sel_Leaf.child[j]=temp;
				int ind = tree.indexOf(sel_Leaf);
				sel_Leaf.isleaf = false;
				tree.set(ind, sel_Leaf);
				tree.addLast(temp);
				Leaf.addLast(temp);
				sibpos++;
				cnt++;
				
			}
		}
		/*
		 * Tree Traversal
		 */
		Node t = new Node();
		t = (Node)tree.getFirst();
		System.out.println(t.toString());
		System.out.println("size is "+tree.size());
		System.out.println(" "+t.child[0].toString());
		tree(root);
		return root;
	}
	
	
	public static Node tree()
	{
		int cnt=0;
		int sibpos=0;
		LinkedList tree = new LinkedList();
		LinkedList Leaf = new LinkedList();
		Node root = new Node();
		root.nodeID = 0;
		root.parentID = -1;
		root.sibpos  = -1;
		root.isleaf = true;
		Leaf.addLast(root);
		tree.addLast(root);
		cnt++;
		int k = 100;
		for(int i=0;i<k-1;i++)
		{ 
			int s = Leaf.size();
			RandomVal rndI = new RandomVal();
			int sl = rndI.getInt(0, s-1);
			Node sel_Leaf = (Node)Leaf.get(sl);
			Leaf.remove(sl);
			/*
			 * Generate a random value for this
			 */
			Random gauss = new Random();
			int mean =5;
			double stdDev = 5.0;
			int no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			while(no_child<=0)
			{
				no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			}
			sibpos=0;
			sel_Leaf.child=new Node[no_child];
			for(int j=0;j<no_child;j++)
			{
				Node temp = new Node();
				temp.nodeID=cnt;
				temp.parentID=sel_Leaf.nodeID;
				temp.sibpos=sibpos;
				temp.isleaf=true;
				sel_Leaf.child[j]=temp;
				int ind = tree.indexOf(sel_Leaf);
				sel_Leaf.isleaf = false;
				tree.set(ind, sel_Leaf);
				tree.addLast(temp);
				Leaf.addLast(temp);
				sibpos++;
				cnt++;
				
			}
		}
		/*
		 * Tree Traversal
		 */
		Node t = new Node();
		t = (Node)tree.getFirst();
		System.out.println(t.toString());
		System.out.println("size is "+tree.size());
		System.out.println(" "+t.child[0].toString());
		tree(root);
		return root;
	}
	
	/**
	 * 
	 * @param n
	 * @param k
	 * @param mean
	 * @param stdDev
	 * @param len
	 * @param no_label
	 */
	public static String[] two_tree(int n,int k,int mean,double stdDev,int len,int no_label)
	{
		String trees[]=new String[2];
		set_labels(len,no_label);
		
		LinkedList del = new LinkedList();
		int cnt=0;
		int sibpos=0;
		Random obj = new Random();
		int r = obj.nextInt(labels.size());
		LinkedList tree = new LinkedList();
		LinkedList Leaf = new LinkedList();
		Tree_Generate.set_labels(len, no_label);
		System.out.println("varunesh");
		Node1 root = new Node1();
		root.nodeID = 0;
		root.parentID = -1;
		root.sibpos  = -1;
		root.isleaf = true;
		root.lbl=(String) labels.get(r);
		Leaf.addLast(root);
		tree.addLast(root);
		cnt++;
		
		for(int i=0;i<k-1;i++)
		{ 
			int s = Leaf.size();
			RandomVal rndI = new RandomVal();
			int sl = rndI.getInt(0, s-1);
			Node1 sel_Leaf = (Node1)Leaf.get(sl);
			Leaf.remove(sl);
			/*
			 * Generate a random value for this
			 */
			Random gauss = new Random();
			
			int no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			while(no_child<=0)
			{
				no_child = (int)Math.round(mean + gauss.nextGaussian() * stdDev);
			}
			sibpos=0;
			sel_Leaf.child=new Node1[no_child];
			for(int j=0;j<no_child;j++)
			{
				r = obj.nextInt(labels.size());
				Node1 temp = new Node1();
				temp.nodeID=cnt;
				temp.parentID=sel_Leaf.nodeID;
				temp.sibpos=sibpos;
				temp.isleaf=true;
				temp.lbl=(String) labels.get(r);
				sel_Leaf.child[j]=temp;
				int ind = tree.indexOf(sel_Leaf);
				sel_Leaf.isleaf = false;
				tree.set(ind, sel_Leaf);
				tree.addLast(temp);
				Leaf.addLast(temp);
				sibpos++;
				cnt++;
				
			}
		}
		/*
		 * Tree Traversal
		 */
		Node1 t = new Node1();
		t = (Node1)tree.getFirst();
		String tree1,tree_1;
		tree_1 = tree_label1(root);
		trees[0] = tree_1;
		//tree1 = treefromList(tree,root);
		//System.out.println("tree1 "+tree1);
		System.out.println("tree_1 "+tree_1);
		
		int num;
		Random obj1 = new Random();
		RandomVal rndv = new RandomVal();
		RandomVal random2 = new RandomVal(RandomVal.GAUSS, 1);
		
		/*
		 * Doing the operations on Trees
		 */
		for(int i=0;i<n;i++)
		{
			/*
			 * First select any of the edit operation
			 * 0 - rename
			 * 1 - insert
			 * 2 - delete
			 */
			num = obj.nextInt(1000000);
			
			if(num%3 == 0)
			{
				int nid = rndv.getInt(0,tree.size()-1);
				if(del.contains(nid))
				{
					i--;
				}
				else
				{
					Node1 t1 = (Node1)tree.get(nid);
					r = obj.nextInt(labels.size());
					String nlbl=(String) labels.get(r);
					System.out.println("RENAME "+t1.nodeID+" old label "+t1.lbl+" new label "+nlbl);
					rename(root,nlbl,t1.nodeID);
					tree.set(nid, t1);
				}
			}
			else if(num%3 == 1)
			{
				/*
				 * Select a node randomly
				 * Insert the new node under it
				 */
				int nid = rndv.getInt(1,tree.size()-1);
				if(del.contains(nid))
				{
					//System.out.println("inside");
					i--;
				}
				else
				{
					Node1 t1 = (Node1)tree.get(nid);
					r = obj.nextInt(labels.size());
					if(t1.isleaf)
					{
						String nlbl=(String) labels.get(r);
						System.out.println("INSERT ID "+cnt+" Parent "+t1.nodeID+" label "+nlbl+" k "+ 1+" m "+0);
						insert(root,t1,cnt,nlbl,1,0);
						tree.addLast(inserted);
						if(inserted.isleaf)
						{
							Leaf.addLast(inserted);
						}
						cnt++;
						
					}
					else
					{
						int fanout = t1.child.length;
						int k_t, m_t;
						if (fanout == 0) {
							k_t = 0;
							m_t = 0;
						} 
						else {
							k_t = rndv.getInt(0, fanout-1);
							// try to avoid to many 0s for m...
							m_t = random2.getInt(0, 2*(fanout - k));
							if (m_t < 0) {
								m_t = 0;
							}
							if (m_t > fanout - k_t) {
								m_t = fanout - k_t;
							}
						}
						
						String nlbl=(String) labels.get(r);
						System.out.println("INSERT ID "+cnt+" Parent "+t1.nodeID+" label "+nlbl+" k "+ k_t+" m "+m_t);
						insert(root,t1,cnt,nlbl,k_t,m_t);
						tree.addLast(inserted);
						if(inserted.isleaf)
						{
							Leaf.addLast(inserted);
						}
						cnt++;
					}
				}
			}
			else if(num%3 == 2)
			{
				int nid = rndv.getInt(1,tree.size()-1);
				if(del.contains(nid))
				{
					//System.out.println("inside");
					i--;
				}
				else
				{
					del.addLast(nid);
					Node1 n1 = new Node1();
					Node1 t1 = (Node1)tree.get(nid);
					int id = t1.nodeID;
					System.out.println("DELETE "+nid+" "+t1.lbl+" nodeid "+t1.nodeID);
					int pid = t1.parentID;
					Node1 loop = new Node1();
					Node1 prnt=new Node1();
					Node1 nd  =new Node1();
					nd = root;
					prnt = null;
					delete(root,null,id);
					tree.remove(nid);
					
				}
			}
			else
			{
				System.out.println("no satisfaction");
			}
		}
		String tree2;
		Node1 root2 = (Node1)tree.getFirst();
		tree2 = tree_label1(root);
		trees[1] = tree2;
		System.out.println("tree2 "+tree2);
		return trees;
		
	}
	
	
	
	public static void main(String args[])
	{
		for(int p=0;p<100;p++)
		{
			System.out.println("p "+p);
			Tree_Generate.two_tree(20, 5, 5, 2.0, 2, 3);
		}
		
	}
	

	
	
}
