 /*
 * Created on Sep 30, 2005
 */

package mainmemory;





import java.io.*;
import java.util.*;
import mysqltools.MySqlInsertBuffer;
import sqltools.*;
import hash.*;
import index.*;
import random.*;
import adjacencyenc.*;
import java.sql.*;
import mainmemupdate.*;
import configuration.*;


/**
 * @author Varunesh Mishra
 */
public class TreeUpdateSeqm {
	
	/**
	 * Changes tree and writes Log for numEditOp edit operations. 
	 * Half of them are random inserts, half of them random deletes.
	 * @param f
	 * @param treeID
	 * @param numEditOps
	 * @throws SQLException
	 */
	public static void editSequence(AdjacencyEncForest f, int treeID, int numEditOps) 
	throws SQLException {
		
		int p=DoEditOpsOnTreem.pval();
		int q=DoEditOpsOnTreem.qval();
		Index idx=DoEditOpsOnTreem.getidx();
		pqgrams pqgramobj=new pqgrams(p,q);
		f.setWriteLog(true);
		int maxNodeID = f.getFreeNodeID(treeID, f.getStatement());
		RandomVal random = new RandomVal(1);
		RandomVal random2 = new RandomVal(RandomVal.GAUSS, 1);
		for (int i = 0; i < numEditOps; i++) {
			int nodeID = random.getInt(0, maxNodeID);
		//	System.out.println(nodeID);
			if (nodeID % 2 == 1) { // odd nodeIDs, is never root (nodeID=0)
				f.renameNode(new Integer(treeID), new Integer(nodeID), "R" + i);
				String new_label="R"+i;
		//		System.out.println(Integer(treeID)+Integer);
					StringBuffer sb[];
					pqgrams obj=new pqgrams(p,q);
					sb=obj.getpqgrams(f,treeID,nodeID);
					List_Buffer_PParts_QParts ren=new List_Buffer_PParts_QParts();
					getpparts getparent=new getpparts();
					
					System.out.println("K to K+q-1 parts");
					
					int parentID=getparent.parentid(f,treeID,nodeID,idx.getHf());
					int sibpos=getparent.sibposition(f,treeID,nodeID,idx.getHf());
					System.out.println(parentID);
					System.out.println(sibpos);
					ren.pqgramkk(f, sibpos, sibpos,p,q, treeID, parentID,idx.getHf());
					System.out.println("Here starts the ppart update");
					LinkedList lstold = new LinkedList();
					getpparts getp=new getpparts();
					lstold=getp.getAnchestors(f,treeID,nodeID,p,idx.getHf());
					System.out.println(nodeID);
					PPart_QPart_List pplist=new PPart_QPart_List(0,p-1,nodeID,f,lstold);
					pplist.pparts(treeID, nodeID, idx.getHf());
			/*  getpparts obj=new getpparts();
			    //LinkedList str=obj.getAnchestors(f,treeID,nodeID,p,idx.getHf());
			    //int s1=str.size();
			    //System.out.println(s1);
			    //StringBuffer sb = new StringBuffer();
		        for (ListIterator it = str.listIterator(str.size()); it.hasPrevious();) {
			           String s = ((HashValue)it.previous()).toString();
			           sb.append(s);
		        }	
		//	sb.append("v");	
		        getqparts obj2=new getqparts();
		        String childs = obj2.getQ_children_str(f,treeID,nodeID);
		        System.out.println(childs);
			    System.out.println(sb.length());
			    System.out.println(sb);
		*/			
					
					
					
					
				//System.err.println(f.getEditLog().getLast());
			} else {
				int fanout = f.getChildCount(treeID, nodeID);
				int k, m;
				if (fanout == 0) {
					k = 1;
					m = 0;
				} else {
					k = random.getInt(1, fanout);
					// try to avoid to many 0s for m...
					m = random2.getInt(0, 2*(fanout - k));
					if (m < 0) {
						m = 0;
					}
					if (m > fanout - k) {
						m = fanout - k;
					}
				}
				f.insertNode(new Integer(treeID), f.getFreeNodeID(treeID, f.getStatement()), 
						"I" + i, new Integer(nodeID), k, m);
						StringBuffer sb[];
					pqgrams obj=new pqgrams(p,q);
					sb=obj.getpqgrams(f,treeID,nodeID);
					//	getpparts obj=new getpparts();
		/*	LinkedList str=obj.getAnchestors(f,treeID,nodeID,p,idx.getHf());
			int s1=str.size();
			System.out.println(s1);
			StringBuffer sb = new StringBuffer();
		for (ListIterator it = str.listIterator(str.size()); it.hasPrevious();) {
			String s = ((HashValue)it.previous()).toString();
			sb.append(s);
		}	
		//	sb.append("v");	
		    getqparts obj2=new getqparts();
		    String childs = obj2.getQ_children_str(f,treeID,nodeID);
		    System.out.println(childs+"varun");
			System.out.println(sb.length());
			System.out.println(sb);
						
	*/					
				//System.err.println(f.getEditLog().getLast() + " (fanout: " + fanout + ")");
			}
		}
	}
	
	/**
	 * 
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 5) {
			System.err.println("\nApplies <numEditOps> to tree <treeID> in <tblName>.\n"
					+ "Assumes a pq-gram index <tblName>_Idx_<p><q> being already there.\n"
					+ "Further a table <tblName>_bak is assumed (copy of <tblName>).\n"
					+ "The edit operations will be executed on the tree, \n" 
					+ "and then the index is updated from the log.\n");
			System.err.println("  params: tblName treeID p q numEditOps\n");
			System.exit(-1);
		}
		String tblName = args[0];
		int treeID = Integer.parseInt(args[1]);
		int p = Integer.parseInt(args[2]);
		int q = Integer.parseInt(args[3]);
		int numEditOps = Integer.parseInt(args[4]);
		
		// connect to database
		// connect to database
		Connection[] con = Configuration.getCons(2);
		Connection out = con[0];
		Connection in = con[1];
		
		AdjacencyEncForest f = new AdjacencyEncForest(out, in,
				new MySqlInsertBuffer(), tblName);
//		AdjacencyEncForest f_bak = new AdjacencyEncForest(out, in,
//				new MySqlInsertBuffer(), tblName + "_bak");
//		String idxName = tblName + "_Idx_" + p + q;
//		Index idx = new Index(idxName, out, p, q, new hash.StringHash(4));
		
		SQLTools.DEBUG = false;
		long start = System.currentTimeMillis();
		System.err.println("Doing edit operations on tree...");
		editSequence(f, treeID, numEditOps);
		System.err.println("...took me " + (System.currentTimeMillis() - start) + "ms.\n");

//		start = System.currentTimeMillis();
//		System.err.println("Updating index...");
//		idx.update(f);
//		System.err.println("...took me " + (System.currentTimeMillis() - start) + "ms.");
				
//		start = System.currentTimeMillis();
//		System.err.println("Restoring original tree...");
//		f.undoEditLog();
//		System.err.println("...took me " + (System.currentTimeMillis() - start) + "ms.");
//		
//		if (f.equals(f_bak)) {
//			System.err.println("The restore operation was successful!");
//		} else {
//			System.err.println("Something went WRONG in the restore operation...");
//		}
			
		
	}

}
