package mainmemupdate;


import adjacencyenc.AdjacencyEncForest;
import configuration.*;
import com.mysql.jdbc.Connection;

import hash.FixedLengthHash;

import java.sql.*;
import java.util.LinkedList;

import mainmemory.*;

public class Update_Index {
	
	public int operation;
	public String new_label;
	
	public Update_Index(int operation,String new_label)
	{
		
	}
	
	public void add_data() throws Exception
	{
		Connection[] con=(Connection[]) Configuration.getCons(1);
		//con[0]
	}
	
	public void delete_pqgrams(StringBuffer old_pqg[],int treeID, String tblname) throws Exception
	{
		/*
		 * First find whether the given string is present 
		 * in MYSQL or not, if yes then just decrement the 
		 * counter by one.
		 */
		java.sql.Connection[] con= Configuration.getCons(1);
		
		int size=old_pqg.length;
		boolean check=false;
		for(int i=0;i<size;i++)
		{
			String query;
			query="SELECT * FROM `"+tblname+"`"+
				  " WHERE `treeID` = "+treeID+
				  " AND `pqgram`="+"\""+old_pqg[i]+"\"";
			System.out.println(query);
			Statement st=con[0].createStatement();
			ResultSet rs=st.executeQuery(query);
			while(rs.next())
			{
				int count=rs.getInt("cnt");
				int trID=rs.getInt("treeID");
				String name=rs.getString("pqgram");
				System.out.println(count+1);
				check=true;
				if(count==1)
				{
					/*
					 * Count was found to be 1 
					 * Deleting the pq gram present
					 */
					String delete="DELETE FROM `"+tblname+"`"+
								  "WHERE `treeID`="+treeID+" AND "+
								  "`pqgram`="+"\""+old_pqg[i]+"\"";
					Statement del=con[0].createStatement();
					del.executeUpdate(delete);
					System.out.println("Deleting the Row");
					
				}
				else
				{
					/*
					 * Updating the count value by 
					 *  Decreasing it by 1
					 */
					String decrement="Update `"+tblname+"`"+
	                  				 " SET `cnt`="+(count-1)+
	                  				 " WHERE `treeID`="+treeID+" AND "+
	                  				 "`pqgram`="+"\""+old_pqg[i]+"\"";
					Statement decr=con[0].createStatement();
					decr.executeUpdate(decrement);
					System.out.println("Count Decremented by one");
					
				}
			}
			
		}
		
		if(check)
		{
			System.out.println("Some Data was there");
		}
		else
		{
			System.out.println("No Data Matches or No Data is present");
		}
		
	}
	
	public void add_pqgrams(StringBuffer new_pqg[],int treeID, String tblname) throws Exception,SQLException
	{
		
		java.sql.Connection[] con= Configuration.getCons(1);
		/*
		 * Check if the given pq gram is in the table if yes
		 * then just increment the corresponding cnt  by  1 
		 * otherwise inset the data in a new  row  with  the 
		 * initial value of cnt to be 1
		 */
		int size=new_pqg.length;
		boolean check=false;
		for(int i=0;i<size;i++)
		{
			String query;
			query="SELECT * FROM `"+tblname+"`"+
				  " WHERE `treeID` = "+treeID+
				  " AND `pqgram`="+"\""+new_pqg[i]+"\"";
			System.out.println(query);
			Statement st=con[0].createStatement();
			ResultSet rs=st.executeQuery(query);
			int count=0;
			while(rs.next())
			{
				count=rs.getInt("cnt");
				int trID=rs.getInt("treeID");
				String name=rs.getString("pqgram");
				System.out.println(count+1);
				check=true;
				
			}
			if(check==false)
			{
				/*
				 * Insert a new row in the table
				 */
				String insert="Insert Into `"+tblname+"`(treeID,pqgram,cnt) VALUES("+
							   treeID+","+"\""+new_pqg[i]+"\""+","+(count+1)+")";
				Statement sti=con[0].createStatement();
				st.executeUpdate(insert);
				System.out.println("row inserted");
			}
			else
			{
				/*
				 * Decrease the value of cnt by 1
				 */
				
				String increment="Update `"+tblname+"`"+
				                  " SET `cnt`="+(count+1)+
				                  " WHERE `treeID`="+treeID+" AND "+
				                  "`pqgram`="+"\""+new_pqg[i]+"\"";
				System.out.println(increment);
				Statement std=con[0].createStatement();
				std.executeUpdate(increment);
				System.out.println("Count Incremented By 1");
			}
			check=false;
			
			
		}
		
		
		
		
		
	}
	
	
	@SuppressWarnings("unchecked")
	public void update_first(AdjacencyEncForest f, int treeID, int nodeID, int length,
			FixedLengthHash hf) throws Exception
	{
		/*
		 * This function will call the required functions to retrieve the 
		 * modified linkedlist and side by side normal linkedlist
		 */
		
		/*
		 * Get P(v) . Q(v) and simultaneously update them with required operation
		 */
		String m=null;
		String tablename=DoEditOpsOnTreem.get_table_name();
		
		getpparts prntid_sibpos=new getpparts();
		List_Buffer_PParts_QParts ppart_qpart=new List_Buffer_PParts_QParts();
		Qkm_operations op_Dm=new Qkm_operations(m);
		Qpartsload qpart_buffer=new Qpartsload();
		ppartload ppart_buffer=new ppartload();
		mergeppartandqparts merge=new mergeppartandqparts();
		
		
		int qval=DoEditOpsOnTreem.getQvalue();
		int parentID=prntid_sibpos.parentid(f, treeID, nodeID, hf);
		int k=prntid_sibpos.sibposition(f, treeID, nodeID, hf);   // k is the sibling position
		
		StringBuffer Q_old_buffer[] = null;
		StringBuffer Q_new_buffer[] = null;
		StringBuffer P_Part=new StringBuffer();
		
		
		LinkedList p;
		LinkedList q[];
		LinkedList q_new[];
		
		p=ppart_qpart.parentppart_List(f, treeID, nodeID, length, hf);
		q=ppart_qpart.qpart_kk(f, k, length, qval, treeID, parentID, hf);
		/*
		 * Performing the operation on Q parts
		 */
		
		
		
		q_new=op_Dm.operation_Dm_L(q);
		P_Part=ppart_buffer.ppart(p);
		Q_old_buffer=qpart_buffer.qparts(q);
		Q_new_buffer=qpart_buffer.qparts(q_new);
		
		/*
		 * Merging P Parts and Q Parts
		 */
		
		Q_old_buffer=merge.pq_merge(Q_old_buffer,P_Part);
		Q_new_buffer=merge.pq_merge(Q_new_buffer,P_Part);
		
		/*
		 * Updating the Index
		 */
		delete_pqgrams(Q_old_buffer, 0, tablename);
		add_pqgrams(Q_new_buffer, 0, tablename);
		
		
	}

	
	public static void main(String args[]) throws SQLException, Exception
	{
		StringBuffer[] sb=new StringBuffer[6];
		sb[0]=new StringBuffer("varun");
		sb[1]=new StringBuffer("vasudha");
		sb[2]=new StringBuffer("mummy");
		sb[3]=new StringBuffer("sancy");
		sb[4]=new StringBuffer("lale");
		sb[5]=new StringBuffer("manee");
		Update_Index obj=new Update_Index(0,null);
		obj.delete_pqgrams(sb,1,"update_demo");
		
			
		
		
	}
}
