package indexing;

import java.util.Iterator;
import java.util.LinkedList;

import distance.Profile;

public class Experiment {
	
	public static void main(String args[])
	{
		Assign_references obj = new Assign_references(3,3);
		Generate_Data gd = new Generate_Data(3,3);
		References robj = new References();
		LinkedList ref = new LinkedList();
		int n = 400;
		int len = 2;
		int no_label = 10;
		boolean normalized = false;
		gd.generate_database(n, len, no_label, normalized);
		gd.generate_query(50);
		robj.pq_profiles_List = gd.Profs;
		
		ref = robj.reference_set(50, 3, 3, .015);
		//System.out.println("SSSSSSSSSref.size "+ref.size());
		for(Iterator it = ref.iterator(); it.hasNext();) {
			Profile v = (Profile)it.next();
			int i1 = 0;
			System.out.println("Varunesh Mishra");
			while(i1 < v.size())
			{
				System.out.print(v.elementAt(i1));
				i1++;
			}
			System.out.println();
		}
		/*
		 * After selecting the References 
		 */
		//obj.N_Profile_List = gd.Profs;
		obj.generate_query(25, gd.Profs);
		obj.assign_Dis(ref, gd.Profs);
		obj.assign_Disq(ref, gd.Profs);
		obj.assignment(gd.Profs, ref, 25);
		System.out.println("Varunesh Mishra indexing"+ref.size());
		
		for(int i=0;i<gd.Qry.size();i++)
		{
			System.out.println("QUERY i "+i);
			Query temp = (Query)gd.Qry.get(i);
			System.out.println("inside experiment "+temp.prf_ind);
			//System.out.println("")
			obj.range_search((Query)gd.Qry.get(i), ref, gd.Profs);
		}
		System.out.println("The DATASIZE is "+n);
		System.out.println("The DISK I/O WITH ALGORITM "+Assign_references.dsk_io);
		System.out.println("The DISK I/O WITHOUT ALGORITM "+Assign_references.dsk_io_e);
		System.out.println("SELECTIVITY "+(1-(double)Assign_references.dsk_io/(double)Assign_references.dsk_io_e));
		
		
		
		
	}
	

}
