/*
 * Created on Sep 28, 2005
 */
package index;

import java.sql.SQLException;

/**
 * Any edit operation that is supported by the the {@link index.Editable} interface.
 * 
 * @author Varunesh Mishra
 */
abstract public class EditOperation {
	abstract public void applyTo(Editable editable) throws SQLException;	
	abstract public EditOperation reverseEditOp();
	@Override
	abstract public String toString();
	/*
	 * 16 July 2009
	 * Added the following three function 
	 * These function are mainly used deletion operation
	 */
	abstract public boolean isDelete();
	abstract public Object getTreeID();
	abstract public Object getNode();
	abstract public Object parent();
	abstract public int retopcode();
	abstract public int retk();
	abstract public int retm();
	abstract public String retnewLabel();
}