/*
 * Created on Jan 20, 2005
 */
package tree;

/**
 * A tree that implements the standard edit operations (delete,insert,relabel).
 * 
 * @author augsten
 */
public interface EditTree {

	public static final int TREE_EMPTY = -1;
	
	public boolean relabelNode(String label);

	/**
	 * 
	 * @param nodeOfTree a node of the tree to be deleted
	 * @return true, if node was deleted successfully
	 */
	public boolean deleteNode(Object nodeOfTree);

	public boolean insertNode(Object newNode, int i, int k);	

	public int deletePath(Object path);
	
	public boolean insertPath(Object path);
	
	
	
}
